
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega128L
;Program type             : Application
;Clock frequency          : 7,372800 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 1024 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega128L
	#pragma AVRPART MEMORY PROG_FLASH 131072
	#pragma AVRPART MEMORY EEPROM 4096
	#pragma AVRPART MEMORY INT_SRAM SIZE 4351
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0100
	.EQU __SRAM_END=0x10FF
	.EQU __DSTACK_SIZE=0x0400
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _rx_index=R5
	.DEF _tx_index=R4
	.DEF _pause=R6
	.DEF _ocra=R8
	.DEF _current_servo=R11

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _usart0_rx_isr
	JMP  0x00
	JMP  _usart0_tx_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer3_compa_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0004

_0x3:
	.DB  0xB8,0xB,0xB8,0xB,0xB8,0xB,0xB8,0xB
	.DB  0xB8,0xB,0xB8,0xB,0xB8,0xB,0xB8,0xB
	.DB  0xB8,0xB
_0x69:
	.DB  0x0,0x48,0xD0,0x7,0x0,0x1

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x12
	.DW  _servo_position
	.DW  _0x3*2

	.DW  0x06
	.DW  0x06
	.DW  _0x69*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

	OUT  RAMPZ,R24

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x500

	.CSEG
;#include <mega128.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <adc.h>
;
;
;                                                     //Global variables
;signed char rx_buffer[RX_BUFFER_SIZE];
;unsigned char rx_index;
;bit status_rx_buffer=EMPTY;
;
;signed char tx_buffer[TX_BUFFER_SIZE];
;unsigned  char tx_index;
;bit status_tx_buffer;
;
;int servo_position[9]={3000,3000,3000,3000,3000,3000,3000,3000,3000};

	.DSEG
;int pause=18432;
;int ocra=2000;
;char current_servo=1;
;
;bit radar_move=1;
;
;
;                                                      //Interrupt's
;
;interrupt [USART0_RXC] void usart0_rx_isr(void)
; 0000 001A {

	.CSEG
_usart0_rx_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 001B signed char status,data;
; 0000 001C status=UCSR0A;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	IN   R17,11
; 0000 001D data=UDR0;
	IN   R16,12
; 0000 001E if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x4
; 0000 001F    {rx_buffer[rx_index++]=data;}
	MOV  R30,R5
	INC  R5
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	ST   Z,R16
; 0000 0020 if (rx_index == RX_BUFFER_SIZE)
_0x4:
	LDI  R30,LOW(3)
	CP   R30,R5
	BRNE _0x5
; 0000 0021  {
; 0000 0022  rx_index=0;
	CLR  R5
; 0000 0023  status_rx_buffer=FULL;
	SET
	RJMP _0x65
; 0000 0024  }
; 0000 0025 else
_0x5:
; 0000 0026  {status_rx_buffer=EMPTY;}
	CLT
_0x65:
	BLD  R2,0
; 0000 0027 }
	LD   R16,Y+
	LD   R17,Y+
	RJMP _0x68
;
;
;interrupt [USART0_TXC] void usart0_tx_isr(void)
; 0000 002B {
_usart0_tx_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 002C   UDR0=tx_buffer[tx_index++];
	MOV  R30,R4
	INC  R4
	LDI  R31,0
	SUBI R30,LOW(-_tx_buffer)
	SBCI R31,HIGH(-_tx_buffer)
	LD   R30,Z
	OUT  0xC,R30
; 0000 002D   if (tx_index == TX_BUFFER_SIZE)
	LDI  R30,LOW(3)
	CP   R30,R4
	BRNE _0x7
; 0000 002E   {
; 0000 002F   tx_index=0;
	CLR  R4
; 0000 0030   status_tx_buffer=EMPTY;
	CLT
	BLD  R2,1
; 0000 0031   tx_interrupt_off;
	CBI  0xA,6
; 0000 0032   }
; 0000 0033   else
	RJMP _0x8
_0x7:
; 0000 0034   {status_tx_buffer=FULL;}
	SET
	BLD  R2,1
_0x8:
; 0000 0035 }
_0x68:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;
;
;interrupt [TIM3_COMPA] void timer3_compa_isr(void)
; 0000 0039 {
_timer3_compa_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 003A TCCR3A |=(1<<FOC3A);
	LDS  R30,139
	ORI  R30,0x80
	STS  139,R30
; 0000 003B 
; 0000 003C         if (current_servo == 9)
	LDI  R30,LOW(9)
	CP   R30,R11
	BRNE _0x9
; 0000 003D         {
; 0000 003E          current_servo = 0;
	CLR  R11
; 0000 003F          ocra += pause;
	__ADDWRR 8,9,6,7
; 0000 0040          OCR3AH=(ocra>>8);
	RCALL SUBOPT_0x0
; 0000 0041          OCR3AL=ocra;
; 0000 0042          pause = 18432;
	LDI  R30,LOW(18432)
	LDI  R31,HIGH(18432)
	MOVW R6,R30
; 0000 0043         }
; 0000 0044         else
	RJMP _0xA
_0x9:
; 0000 0045         {
; 0000 0046          ocra += servo_position[current_servo];
	RCALL SUBOPT_0x1
	__ADDWRR 8,9,30,31
; 0000 0047          OCR3AH=(ocra>>8);
	RCALL SUBOPT_0x0
; 0000 0048          OCR3AL=ocra;
; 0000 0049          pause -= servo_position[current_servo];
	RCALL SUBOPT_0x1
	__SUBWRR 6,7,30,31
; 0000 004A          current_servo++;
	INC  R11
; 0000 004B         }
_0xA:
; 0000 004C 
; 0000 004D }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;
;
;
;void main(void)
; 0000 0052 {
_main:
; 0000 0053 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0054 uart_start();
	RCALL _uart_start
; 0000 0055 #asm("sei")
	sei
; 0000 0056 
; 0000 0057 
; 0000 0058  while (1)
_0xB:
; 0000 0059  {
; 0000 005A   while(status_rx_buffer==EMPTY);
_0xE:
	SBRS R2,0
	RJMP _0xE
; 0000 005B   switch (function)
	LDS  R30,_rx_buffer
	LDI  R31,0
	SBRC R30,7
	SER  R31
; 0000 005C   {
; 0000 005D   case RADAR:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x14
; 0000 005E   radar();
	RCALL _radar
; 0000 005F   break;
	RJMP _0x13
; 0000 0060 
; 0000 0061   case ROBOMD2:
_0x14:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x15
; 0000 0062   robomd2(param1,param2);
	RCALL SUBOPT_0x2
	RCALL _robomd2
; 0000 0063   while(status_tx_buffer==FULL);
_0x16:
	SBRC R2,1
	RJMP _0x16
; 0000 0064   funct_for_pc=ROBOMD2;
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x3
; 0000 0065   tx_interrupt_on;
; 0000 0066   param1_for_pc=param1;
; 0000 0067   param2_for_pc=param2;
	RJMP _0x66
; 0000 0068   break;
; 0000 0069 
; 0000 006A   case SERVO:
_0x15:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x19
; 0000 006B   servo(param1,param2);
	RCALL SUBOPT_0x2
	RCALL _servo
; 0000 006C   while(status_tx_buffer==FULL);
_0x1A:
	SBRC R2,1
	RJMP _0x1A
; 0000 006D   funct_for_pc=SERVO;
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x3
; 0000 006E   tx_interrupt_on;
; 0000 006F   param1_for_pc=param1;
; 0000 0070   param2_for_pc=param2;
	RJMP _0x66
; 0000 0071   break;
; 0000 0072 
; 0000 0073   case ADC_FUNCT:
_0x19:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x13
; 0000 0074   //char vol
; 0000 0075   start_adc(param1);
	__GETB1MN _rx_buffer,1
	ST   -Y,R30
	RCALL _start_adc
; 0000 0076   while(status_tx_buffer==FULL);
_0x1E:
	SBRC R2,1
	RJMP _0x1E
; 0000 0077   funct_for_pc=ADC_FUNCT;
	LDI  R30,LOW(4)
	STS  _tx_buffer,R30
; 0000 0078   tx_interrupt_on;
	SBI  0xA,6
; 0000 0079   param1_for_pc=(reed_adc()/5);
	RCALL _reed_adc
	LDI  R31,0
	MOVW R26,R30
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CALL __DIVW21
	__PUTB1MN _tx_buffer,1
; 0000 007A   param2_for_pc=0;
	LDI  R30,LOW(0)
_0x66:
	__PUTB1MN _tx_buffer,2
; 0000 007B 
; 0000 007C   }
_0x13:
; 0000 007D  }
	RJMP _0xB
; 0000 007E 
; 0000 007F }
_0x21:
	RJMP _0x21
;
;                                              //      ADC functions
;
;void start_adc (signed char adc_chanel)
; 0000 0084 {
_start_adc:
; 0000 0085 if (adc_chanel>9){adc_chanel=9;}
;	adc_chanel -> Y+0
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRLT _0x22
	LDI  R30,LOW(9)
	ST   Y,R30
; 0000 0086 if (adc_chanel<0){adc_chanel=0;}
_0x22:
	LD   R26,Y
	CPI  R26,0
	BRGE _0x23
	LDI  R30,LOW(0)
	ST   Y,R30
; 0000 0087 if (adc_chanel==9)
_0x23:
	LD   R26,Y
	CPI  R26,LOW(0x9)
	BRNE _0x24
; 0000 0088 {ADC_OFF;}
	CBI  0x6,7
; 0000 0089 else if
	RJMP _0x25
_0x24:
; 0000 008A (ADC==OFF)
	SBIC 0x6,7
	RJMP _0x26
; 0000 008B {ADCSRA=(1<<ADEN)|(1<<ADPS1);}
	LDI  R30,LOW(130)
	OUT  0x6,R30
; 0000 008C ADMUX=(1<<REFS0)|(1<ADLAR)|adc_chanel;
_0x26:
_0x25:
	LD   R30,Y
	ORI  R30,LOW(0x41)
	OUT  0x7,R30
; 0000 008D ADCSRA|=(1<<ADSC);
	SBI  0x6,6
; 0000 008E }
	RJMP _0x2000004
;
;char reed_adc (void)
; 0000 0091 {
_reed_adc:
; 0000 0092 while ((ADCSRA.4)==0);
_0x27:
	SBIS 0x6,4
	RJMP _0x27
; 0000 0093 ADCSRA|=(1<<ADIF);
	SBI  0x6,4
; 0000 0094 return ADCH;
	IN   R30,0x5
	RET
; 0000 0095 }
;
;
;
;                                                  //Servo functions
;
;
;void servo (signed char servo, signed char pos)
; 0000 009D {
_servo:
; 0000 009E int position;
; 0000 009F if ((servo&&pos)==0)
	ST   -Y,R17
	ST   -Y,R16
;	servo -> Y+3
;	pos -> Y+2
;	position -> R16,R17
	LDD  R30,Y+3
	CPI  R30,0
	BREQ _0x2B
	LDD  R30,Y+2
	CPI  R30,0
	BRNE _0x2A
_0x2B:
; 0000 00A0 {
; 0000 00A1 servo_off();
	RCALL _servo_off
; 0000 00A2 return;
	RJMP _0x2000005
; 0000 00A3 }
; 0000 00A4 else if(SERV==OFF){servo_on();}
_0x2A:
	IN   R30,0x2
	CPI  R30,0
	BRNE _0x2F
	LDS  R30,139
	CPI  R30,0
	BRNE _0x2F
	LDS  R30,138
	CPI  R30,0
	BREQ _0x30
_0x2F:
	RJMP _0x2E
_0x30:
	RCALL _servo_on
; 0000 00A5 if (servo>8){servo=8;}
_0x2E:
	LDD  R26,Y+3
	CPI  R26,LOW(0x9)
	BRLT _0x31
	LDI  R30,LOW(8)
	STD  Y+3,R30
; 0000 00A6 if (servo<1){servo=1;}
_0x31:
	LDD  R26,Y+3
	CPI  R26,LOW(0x1)
	BRGE _0x32
	LDI  R30,LOW(1)
	STD  Y+3,R30
; 0000 00A7 if (pos>85){pos=85;}
_0x32:
	LDD  R26,Y+2
	CPI  R26,LOW(0x56)
	BRLT _0x33
	LDI  R30,LOW(85)
	STD  Y+2,R30
; 0000 00A8 if (pos<-85){pos=-85;}
_0x33:
	LDD  R26,Y+2
	CPI  R26,LOW(0xAB)
	BRGE _0x34
	LDI  R30,LOW(171)
	STD  Y+2,R30
; 0000 00A9 position = ((5,55*pos+1500)*2);
_0x34:
	LDI  R30,LOW(5)
	LDD  R30,Y+2
	LDI  R26,LOW(55)
	MULS R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-1500)
	SBCI R31,HIGH(-1500)
	LSL  R30
	ROL  R31
	MOVW R16,R30
; 0000 00AA servo_position[servo]=position;
	LDD  R30,Y+3
	LDI  R26,LOW(_servo_position)
	LDI  R27,HIGH(_servo_position)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R16
	STD  Z+1,R17
; 0000 00AB }
_0x2000005:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	RET
;
;void servo_on (void)
; 0000 00AE {
_servo_on:
; 0000 00AF DDRE|=(1<<DDE3)|(1<<DDE2);
	IN   R30,0x2
	ORI  R30,LOW(0xC)
	OUT  0x2,R30
; 0000 00B0 PORTE&=~(1<<PORTE3)|(1<<PORTE2);
	CBI  0x3,3
; 0000 00B1 PORTE.2=1;
	SBI  0x3,2
; 0000 00B2 OCR3AH=0b00000111;
	LDI  R30,LOW(7)
	STS  135,R30
; 0000 00B3 OCR3AL=0b11010000;
	LDI  R30,LOW(208)
	STS  134,R30
; 0000 00B4 TCCR3A=(1<<COM3A0);
	LDI  R30,LOW(64)
	STS  139,R30
; 0000 00B5 TCCR3B=(1<<CS31);
	LDI  R30,LOW(2)
	STS  138,R30
; 0000 00B6 EIMSK|=(1<<OCIE3A);
	IN   R30,0x39
	ORI  R30,0x10
	OUT  0x39,R30
; 0000 00B7 PORTE.2=0;
	CBI  0x3,2
; 0000 00B8 }
	RET
;
;void servo_off (void)
; 0000 00BB {
_servo_off:
; 0000 00BC DDRE&=~(1<<DDE3)|(1<<DDE2);
	CBI  0x2,3
; 0000 00BD TCCR3A=0x00;
	LDI  R30,LOW(0)
	STS  139,R30
; 0000 00BE TCCR3B=0x00;
	STS  138,R30
; 0000 00BF EIMSK&=~(1<<OCIE3A);
	IN   R30,0x39
	ANDI R30,0xEF
	OUT  0x39,R30
; 0000 00C0 }
	RET
;
;signed char get_servo_position (char servo)
; 0000 00C3 {
_get_servo_position:
; 0000 00C4 signed char position;
; 0000 00C5 position=(((servo_position[servo]/2)-1500)/5,55);
	ST   -Y,R17
;	servo -> Y+1
;	position -> R17
	LDI  R17,LOW(55)
; 0000 00C6 return position;
	RJMP _0x2000003
; 0000 00C7 }
;
;
;                                                  //Motor functions
;
;
;
;void robomd2 (signed char m1, signed char m2)
; 0000 00CF {
_robomd2:
; 0000 00D0  if ((PWM_1==0)&&(PWM_2==0)&&(m1==0)&&(m2==0))
;	m1 -> Y+1
;	m2 -> Y+0
	IN   R30,0x2A
	IN   R31,0x2A+1
	SBIW R30,0
	BRNE _0x3A
	IN   R30,0x28
	IN   R31,0x28+1
	SBIW R30,0
	BRNE _0x3A
	LDD  R26,Y+1
	CPI  R26,LOW(0x0)
	BRNE _0x3A
	LD   R26,Y
	CPI  R26,LOW(0x0)
	BREQ _0x3B
_0x3A:
	RJMP _0x39
_0x3B:
; 0000 00D1  {
; 0000 00D2  pwm_off();
	RCALL _pwm_off
; 0000 00D3  return;
	RJMP _0x2000002
; 0000 00D4  }
; 0000 00D5  else
_0x39:
; 0000 00D6  if(PWM==OFF){pwm_on();}
	IN   R30,0x2F
	CPI  R30,0
	BRNE _0x3E
	IN   R30,0x2E
	CPI  R30,0
	BRNE _0x3E
	IN   R30,0x17
	CPI  R30,0
	BRNE _0x3E
	IN   R30,0x14
	CPI  R30,0
	BREQ _0x3F
_0x3E:
	RJMP _0x3D
_0x3F:
	RCALL _pwm_on
; 0000 00D7 
; 0000 00D8 if (m1>100){m1=100;}
_0x3D:
	LDD  R26,Y+1
	CPI  R26,LOW(0x65)
	BRLT _0x40
	LDI  R30,LOW(100)
	STD  Y+1,R30
; 0000 00D9 if (m1<-100){m1=-100;}
_0x40:
	LDD  R26,Y+1
	CPI  R26,LOW(0x9C)
	BRGE _0x41
	LDI  R30,LOW(156)
	STD  Y+1,R30
; 0000 00DA if (m2>100){m2=100;}
_0x41:
	LD   R26,Y
	CPI  R26,LOW(0x65)
	BRLT _0x42
	LDI  R30,LOW(100)
	ST   Y,R30
; 0000 00DB if (m2<-100){m2=-100;}
_0x42:
	LD   R26,Y
	CPI  R26,LOW(0x9C)
	BRGE _0x43
	LDI  R30,LOW(156)
	ST   Y,R30
; 0000 00DC  motor1(m1);
_0x43:
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _motor1
; 0000 00DD  motor2(m2);
	LD   R30,Y
	ST   -Y,R30
	RCALL _motor2
; 0000 00DE }
	RJMP _0x2000002
;
;void pwm_on(void)
; 0000 00E1 {
_pwm_on:
; 0000 00E2 TCCR1A=0x01;
	LDI  R30,LOW(1)
	OUT  0x2F,R30
; 0000 00E3 TCCR1B=0b00001010;
	LDI  R30,LOW(10)
	OUT  0x2E,R30
; 0000 00E4 DDRB|=(1<<DDB6)|(1<DDB5);
	IN   R30,0x17
	ORI  R30,LOW(0x41)
	OUT  0x17,R30
; 0000 00E5 PORTB&=~(1<<PORTB6)|(1<<PORTB7);
	CBI  0x18,6
; 0000 00E6 DDRC|=(1<<DDC7)|(1<<DDC6);
	IN   R30,0x14
	ORI  R30,LOW(0xC0)
	OUT  0x14,R30
; 0000 00E7 PORTC&=~(1<<PORTC7)|(1<<PORTC6);
	CBI  0x15,7
; 0000 00E8 }
	RET
;void pwm_off(void)
; 0000 00EA {
_pwm_off:
; 0000 00EB TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
; 0000 00EC TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 00ED DDRB&=~(1<<DDB6)|(1<DDB5);
	CBI  0x17,6
; 0000 00EE DDRC&=~(1<<DDC7)|(1<<DDC6);
	CBI  0x14,7
; 0000 00EF }
	RET
;
;void motor1 (signed char m1)
; 0000 00F2 {
_motor1:
; 0000 00F3  if ((m1==0)&&(PWM_1==0))
;	m1 -> Y+0
	LD   R26,Y
	CPI  R26,LOW(0x0)
	BRNE _0x45
	IN   R30,0x2A
	IN   R31,0x2A+1
	SBIW R30,0
	BREQ _0x46
_0x45:
	RJMP _0x44
_0x46:
; 0000 00F4  {
; 0000 00F5  PWM_OFF(1);
	IN   R30,0x2F
	ANDI R30,0x7F
	OUT  0x2F,R30
; 0000 00F6  return;
	RJMP _0x2000004
; 0000 00F7  }
; 0000 00F8  else
_0x44:
; 0000 00F9  if(PWM_1==0)
	IN   R30,0x2A
	IN   R31,0x2A+1
	SBIW R30,0
	BRNE _0x48
; 0000 00FA  {PWM_ON(1);}
	IN   R30,0x2F
	ORI  R30,0x80
	OUT  0x2F,R30
; 0000 00FB 
; 0000 00FC  if(m1>=0)
_0x48:
	LD   R26,Y
	CPI  R26,0
	BRLT _0x49
; 0000 00FD  {FORWARD_M1;}
	CBI  0x15,6
; 0000 00FE  else
	RJMP _0x4C
_0x49:
; 0000 00FF  {REVERS_M1;}
	SBI  0x15,6
_0x4C:
; 0000 0100  motor1_set_pwm(m1);
	LD   R30,Y
	ST   -Y,R30
	RCALL _motor1_set_pwm
; 0000 0101 }
	RJMP _0x2000004
;
;void motor2 (signed char m2)
; 0000 0104 {
_motor2:
; 0000 0105  if ((m2==0)&&(PWM_2==0))
;	m2 -> Y+0
	LD   R26,Y
	CPI  R26,LOW(0x0)
	BRNE _0x50
	IN   R30,0x28
	IN   R31,0x28+1
	SBIW R30,0
	BREQ _0x51
_0x50:
	RJMP _0x4F
_0x51:
; 0000 0106  {
; 0000 0107  PWM_OFF(2);
	IN   R30,0x2F
	ANDI R30,0xDF
	OUT  0x2F,R30
; 0000 0108  return;
	RJMP _0x2000004
; 0000 0109  }
; 0000 010A  else
_0x4F:
; 0000 010B  if(PWM_2==0)
	IN   R30,0x28
	IN   R31,0x28+1
	SBIW R30,0
	BRNE _0x53
; 0000 010C  {PWM_ON(2);}
	IN   R30,0x2F
	ORI  R30,0x20
	OUT  0x2F,R30
; 0000 010D 
; 0000 010E  if(m2>=0)
_0x53:
	LD   R26,Y
	CPI  R26,0
	BRLT _0x54
; 0000 010F  {FORWARD_M2;}
	CBI  0x15,7
; 0000 0110  else
	RJMP _0x57
_0x54:
; 0000 0111  {REVERS_M2;}
	SBI  0x15,7
_0x57:
; 0000 0112  motor2_set_pwm(m2);
	LD   R30,Y
	ST   -Y,R30
	RCALL _motor2_set_pwm
; 0000 0113 }
_0x2000004:
	ADIW R28,1
	RET
;
;void motor1_set_pwm(signed char m1)
; 0000 0116  {
_motor1_set_pwm:
; 0000 0117   unsigned char m1_set_pwm;
; 0000 0118   m1_set_pwm=(m1*255/100);
	RCALL SUBOPT_0x4
;	m1 -> Y+1
;	m1_set_pwm -> R17
; 0000 0119   PWM_1=m1_set_pwm;
	OUT  0x2A+1,R31
	OUT  0x2A,R30
; 0000 011A  }
	RJMP _0x2000001
;
;
;void motor2_set_pwm(signed char m2)
; 0000 011E  {
_motor2_set_pwm:
; 0000 011F   unsigned char m2_set_pwm;
; 0000 0120   m2_set_pwm=(m2*255/100);
	RCALL SUBOPT_0x4
;	m2 -> Y+1
;	m2_set_pwm -> R17
; 0000 0121   PWM_2=m2_set_pwm;
	OUT  0x28+1,R31
	OUT  0x28,R30
; 0000 0122  }
	RJMP _0x2000001
;
;
;
;                                           //radar function
;
;void radar(void)
; 0000 0129 {
_radar:
; 0000 012A //char adc;
; 0000 012B while(status_tx_buffer==FULL)
_0x5A:
	SBRS R2,1
	RJMP _0x5C
; 0000 012C funct_for_pc=RADAR;
	LDI  R30,LOW(1)
	STS  _tx_buffer,R30
	RJMP _0x5A
_0x5C:
; 0000 012D UCSR0B|=(1<<6       );
	SBI  0xA,6
; 0000 012E start_adc(SHARP);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _start_adc
; 0000 012F servo_on();
	RCALL _servo_on
; 0000 0130 switch(radar_move)
	LDI  R30,0
	SBRC R2,2
	LDI  R30,1
; 0000 0131 {
; 0000 0132  case 0:
	CPI  R30,0
	BRNE _0x60
; 0000 0133  if(servo_position[RADAR]<=2500)
	__GETW2MN _servo_position,2
	CPI  R26,LOW(0x9C5)
	LDI  R30,HIGH(0x9C5)
	CPC  R27,R30
	BRGE _0x61
; 0000 0134  {
; 0000 0135  radar_move=1;
	SET
	BLD  R2,2
; 0000 0136  break;
	RJMP _0x5F
; 0000 0137  }
; 0000 0138  servo_position[RADAR]--;
_0x61:
	__POINTW2MN _servo_position,2
	LD   R30,X+
	LD   R31,X+
	SBIW R30,1
	RJMP _0x67
; 0000 0139  break;
; 0000 013A 
; 0000 013B  case 1:
_0x60:
	CPI  R30,LOW(0x1)
	BRNE _0x5F
; 0000 013C  if(servo_position[RADAR]>=3500)
	__GETW2MN _servo_position,2
	CPI  R26,LOW(0xDAC)
	LDI  R30,HIGH(0xDAC)
	CPC  R27,R30
	BRLT _0x63
; 0000 013D  {
; 0000 013E  radar_move=0;
	CLT
	BLD  R2,2
; 0000 013F  break;
	RJMP _0x5F
; 0000 0140  }
; 0000 0141  servo_position[RADAR]++;
_0x63:
	__POINTW2MN _servo_position,2
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
_0x67:
	ST   -X,R31
	ST   -X,R30
; 0000 0142  break;
; 0000 0143 }
_0x5F:
; 0000 0144 
; 0000 0145 param1_for_pc=get_servo_position(RADAR);
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _get_servo_position
	__PUTB1MN _tx_buffer,1
; 0000 0146 //reed_adc();
; 0000 0147 //adc=reed_adc();
; 0000 0148 param2_for_pc=distance(reed_adc());
	RCALL _reed_adc
	ST   -Y,R30
	RCALL _distance
	__PUTB1MN _tx_buffer,2
; 0000 0149 }
	RET
;
;
;signed char distance(char adc)
; 0000 014D {
_distance:
; 0000 014E signed char r;
; 0000 014F if(adc==0){return 0;}
	ST   -Y,R17
;	adc -> Y+1
;	r -> R17
	LDD  R30,Y+1
	CPI  R30,0
	BRNE _0x64
	LDI  R30,LOW(0)
	RJMP _0x2000001
; 0000 0150 r=(2000/(adc+2)-7);
_0x64:
	LDD  R30,Y+1
	LDI  R31,0
	ADIW R30,2
	LDI  R26,LOW(2000)
	LDI  R27,HIGH(2000)
	CALL __DIVW21
	SBIW R30,7
	MOV  R17,R30
; 0000 0151 return r;
_0x2000003:
	MOV  R30,R17
_0x2000001:
	LDD  R17,Y+0
_0x2000002:
	ADIW R28,2
	RET
; 0000 0152 }
;
;                                             //UART function
;
;
;void uart_start(void)
; 0000 0158 {
_uart_start:
; 0000 0159 UCSR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
; 0000 015A UCSR0B=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
; 0000 015B UCSR0C=0x06;
	LDI  R30,LOW(6)
	STS  149,R30
; 0000 015C UBRR0H=0x00;
	LDI  R30,LOW(0)
	STS  144,R30
; 0000 015D UBRR0L=0x30;
	LDI  R30,LOW(48)
	OUT  0x9,R30
; 0000 015E }
	RET

	.DSEG
_rx_buffer:
	.BYTE 0x3
_tx_buffer:
	.BYTE 0x3
_servo_position:
	.BYTE 0x12

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x0:
	MOVW R30,R8
	CALL __ASRW8
	STS  135,R30
	STS  134,R8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1:
	MOV  R30,R11
	LDI  R26,LOW(_servo_position)
	LDI  R27,HIGH(_servo_position)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	__GETB1MN _rx_buffer,1
	ST   -Y,R30
	__GETB1MN _rx_buffer,2
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3:
	STS  _tx_buffer,R30
	SBI  0xA,6
	__GETB1MN _rx_buffer,1
	__PUTB1MN _tx_buffer,1
	__GETB1MN _rx_buffer,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x4:
	ST   -Y,R17
	LDD  R26,Y+1
	LDI  R27,0
	SBRC R26,7
	SER  R27
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	CALL __MULW12
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL __DIVW21
	MOV  R17,R30
	MOV  R30,R17
	LDI  R31,0
	RET


	.CSEG
__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ASRW8:
	MOV  R30,R31
	CLR  R31
	SBRC R30,7
	SER  R31
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

;END OF CODE MARKER
__END_OF_CODE:
