#include <mega128.h>
#include <delay.h>
#include <adc.h>


                                                     //Global variables
signed char rx_buffer[RX_BUFFER_SIZE];
unsigned char rx_index;
bit status_rx_buffer=EMPTY; 

signed char tx_buffer[TX_BUFFER_SIZE];
unsigned  char tx_index;
bit status_tx_buffer;

int servo_position[9]={3000,3000,3000,3000,3000,3000,3000,3000,3000};
int pause=18432;
int ocra=2000;
char current_servo=1;

bit radar_move=1;
                                  

                                                      //Interrupt's

interrupt [USART0_RXC] void usart0_rx_isr(void)
{
signed char status,data;
status=UCSR0A;
data=UDR0;
if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
   {rx_buffer[rx_index++]=data;}
if (rx_index == RX_BUFFER_SIZE) 
 {
 rx_index=0;
 status_rx_buffer=FULL;  
 }
else
 {status_rx_buffer=EMPTY;}
}


interrupt [USART0_TXC] void usart0_tx_isr(void)
{
  UDR0=tx_buffer[tx_index++];
  if (tx_index == TX_BUFFER_SIZE) 
  {
  tx_index=0; 
  status_tx_buffer=EMPTY;
  tx_interrupt_off;
  }
  else
  {status_tx_buffer=FULL;}
}
  

interrupt [TIM3_COMPA] void timer3_compa_isr(void)
{
TCCR3A |=(1<<FOC3A);

        if (current_servo == 9) 
        {
         current_servo = 0;
         ocra += pause;
         OCR3AH=(ocra>>8);
         OCR3AL=ocra;
         pause = 18432;
        } 
        else 
        {
         ocra += servo_position[current_servo];
         OCR3AH=(ocra>>8);
         OCR3AL=ocra;
         pause -= servo_position[current_servo];
         current_servo++;
        }

}



void main(void)
{
ACSR=0x80;
uart_start();
#asm("sei")


 while (1)
 {
  while(status_rx_buffer==EMPTY);
  switch (function)
  {
  case RADAR:
  radar();
  break;

  case ROBOMD2:
  robomd2(param1,param2);
  while(status_tx_buffer==FULL);
  funct_for_pc=ROBOMD2;
  tx_interrupt_on;
  param1_for_pc=param1;
  param2_for_pc=param2;
  break;

  case SERVO:
  servo(param1,param2);
  while(status_tx_buffer==FULL);
  funct_for_pc=SERVO;
  tx_interrupt_on;
  param1_for_pc=param1;
  param2_for_pc=param2;
  break;

  case ADC_FUNCT:
  //char vol
  start_adc(param1);
  while(status_tx_buffer==FULL);
  funct_for_pc=ADC_FUNCT;
  tx_interrupt_on;
  param1_for_pc=(reed_adc()/5);
  param2_for_pc=0;

  }
 }      
     
}                                              

                                              //      ADC functions

void start_adc (signed char adc_chanel)
{
if (adc_chanel>9){adc_chanel=9;}
if (adc_chanel<0){adc_chanel=0;}
if (adc_chanel==9)
{ADC_OFF;}
else if
(ADC==OFF)
{ADCSRA=(1<<ADEN)|(1<<ADPS1);}
ADMUX=(1<<REFS0)|(1<ADLAR)|adc_chanel;
ADCSRA|=(1<<ADSC);
}

char reed_adc (void)
{
while ((ADCSRA.4)==0);
ADCSRA|=(1<<ADIF);
return ADCH;
}

                                                  
                                                  
                                                  //Servo functions


void servo (signed char servo, signed char pos)
{
int position;
if ((servo&&pos)==0)
{
servo_off();
return;
}
else if(SERV==OFF){servo_on();}
if (servo>8){servo=8;}
if (servo<1){servo=1;}
if (pos>85){pos=85;}
if (pos<-85){pos=-85;}
position = ((5,55*pos+1500)*2);
servo_position[servo]=position;
}
 
void servo_on (void)
{
DDRE|=(1<<DDE3)|(1<<DDE2);
PORTE&=~(1<<PORTE3)|(1<<PORTE2);
PORTE.2=1;
OCR3AH=0b00000111;
OCR3AL=0b11010000;
TCCR3A=(1<<COM3A0);
TCCR3B=(1<<CS31);
EIMSK|=(1<<OCIE3A);
PORTE.2=0;
}

void servo_off (void)
{
DDRE&=~(1<<DDE3)|(1<<DDE2);
TCCR3A=0x00;
TCCR3B=0x00;
EIMSK&=~(1<<OCIE3A);
}

signed char get_servo_position (char servo)
{
signed char position;
position=(((servo_position[servo]/2)-1500)/5,55);
return position;
}


                                                  //Motor functions



void robomd2 (signed char m1, signed char m2)
{
 if ((PWM_1==0)&&(PWM_2==0)&&(m1==0)&&(m2==0))
 {
 pwm_off();
 return;
 }
 else
 if(PWM==OFF){pwm_on();}

if (m1>100){m1=100;}
if (m1<-100){m1=-100;}
if (m2>100){m2=100;}
if (m2<-100){m2=-100;}
 motor1(m1);
 motor2(m2);
}

void pwm_on(void)
{
TCCR1A=0x01; 
TCCR1B=0b00001010; 
DDRB|=(1<<DDB6)|(1<DDB5);
PORTB&=~(1<<PORTB6)|(1<<PORTB7); 
DDRC|=(1<<DDC7)|(1<<DDC6);
PORTC&=~(1<<PORTC7)|(1<<PORTC6); 
}
void pwm_off(void)
{
TCCR1A=0x00; 
TCCR1B=0x00; 
DDRB&=~(1<<DDB6)|(1<DDB5);
DDRC&=~(1<<DDC7)|(1<<DDC6);
}

void motor1 (signed char m1)
{
 if ((m1==0)&&(PWM_1==0))
 {
 PWM_OFF(1);
 return;
 }
 else
 if(PWM_1==0)
 {PWM_ON(1);}
 
 if(m1>=0)
 {FORWARD_M1;}
 else
 {REVERS_M1;} 
 motor1_set_pwm(m1); 
}
 
void motor2 (signed char m2)
{
 if ((m2==0)&&(PWM_2==0))
 {
 PWM_OFF(2);
 return;
 }
 else
 if(PWM_2==0)
 {PWM_ON(2);}
 
 if(m2>=0)
 {FORWARD_M2;}
 else
 {REVERS_M2;} 
 motor2_set_pwm(m2);
}

void motor1_set_pwm(signed char m1)
 { 
  unsigned char m1_set_pwm;
  m1_set_pwm=(m1*255/100);
  PWM_1=m1_set_pwm;
 }
 
 
void motor2_set_pwm(signed char m2)
 { 
  unsigned char m2_set_pwm;
  m2_set_pwm=(m2*255/100);
  PWM_2=m2_set_pwm;
 }                  
 
 
   
                                           //radar function
 
void radar(void)
{
//char adc;
while(status_tx_buffer==FULL)
funct_for_pc=RADAR;
tx_interrupt_on;
start_adc(SHARP);
servo_on();
switch(radar_move)
{ 
 case 0:
 if(servo_position[RADAR]<=2500)
 {
 radar_move=1;
 break;
 }
 servo_position[RADAR]--;
 break;
 
 case 1:
 if(servo_position[RADAR]>=3500)
 {
 radar_move=0;
 break;
 }
 servo_position[RADAR]++;
 break;
}

param1_for_pc=get_servo_position(RADAR);
//reed_adc();
//adc=reed_adc();
param2_for_pc=distance(reed_adc());
}


signed char distance(char adc)
{
signed char r;
if(adc==0){return 0;}
r=(2000/(adc+2)-7);
return r;
} 

                                             //UART function
                                             

void uart_start(void)
{
UCSR0A=0x00;
UCSR0B=0x98;
UCSR0C=0x06;
UBRR0H=0x00;
UBRR0L=0x30;
}