#ifndef _ADC_INCLUDED_
#define _ADC_INCLUDED_

#define ADC_OFF ADCSRA&=~(1<<ADEN)
#define ADC  ADCSRA.7   
#define OFF 0
#define ON  1
#define SERV (DDRE||TCCR3A||TCCR3B)
#ifndef RXB8
#define RXB8 1
#endif

#ifndef TXB8
#define TXB8 0
#endif

#ifndef UPE
#define UPE 2
#endif

#ifndef DOR
#define DOR 3
#endif

#ifndef FE
#define FE 4
#endif

#ifndef UDRE
#define UDRE 5
#endif

#ifndef TXC
#define TXC 6
#endif


#ifndef RXC
#define RXC 7
#endif

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<DOR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

#define RX_BUFFER_SIZE 3
#define TX_BUFFER_SIZE 3
#define function   rx_buffer[0]
#define param1     rx_buffer[1]
#define param2     rx_buffer[2]
#define funct_for_pc   tx_buffer[0]
#define param1_for_pc   tx_buffer[1]
#define param2_for_pc   tx_buffer[2]
#define FULL  1
#define EMPTY 0
#define tx_interrupt_on  UCSR0B|=(1<<TXCIE0)
#define tx_interrupt_off UCSR0B&=~(1<<TXCIE0)

#define RADAR   1
#define SHARP   0
#define ROBOMD2 2
#define SERVO   3
#define ADC_FUNCT 4 

#define PWM_1 OCR1A
#define PWM_2 OCR1B
#define PWM (TCCR1A||TCCR1B||DDRB||DDRC)
#define COM_PWM1    (1<<COM1A1)
#define COM_PWM2    (1<<COM1B1)
#define PWM_ON(ch)  TCCR1A|=COM_PWM##ch
#define PWM_OFF(ch) TCCR1A&=~COM_PWM##ch
#define FORWARD_M1  PORTC.6=0
#define FORWARD_M2  PORTC.7=0
#define REVERS_M1   PORTC.6=1
#define REVERS_M2   PORTC.7=1
#pragma used+
signed char distance(char adc);
void radar(void);

void start_adc (signed char adc_chanel);
char reed_adc (void);

void servo (signed char servo, signed char pos);
void servo_on (void);
void servo_off (void);
signed char get_servo_position (char servo);

void robomd2(signed char m1, signed char m2);
void pwm_on(void);
void pwm_off(void);
void motor1(signed char m1);
void motor2(signed char m2);
void motor1_set_pwm(signed char m1);
void motor2_set_pwm(signed char m2);

void uart_start(void);
#pragma used-
#endif
