
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega128L
;Program type             : Application
;Clock frequency          : 7,372800 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 1024 byte(s)
;Heap size                : 24 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega128L
	#pragma AVRPART MEMORY PROG_FLASH 131072
	#pragma AVRPART MEMORY EEPROM 4096
	#pragma AVRPART MEMORY INT_SRAM SIZE 4351
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0100
	.EQU __SRAM_END=0x10FF
	.EQU __DSTACK_SIZE=0x0400
	.EQU __HEAP_SIZE=0x0018
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _rx_index=R5
	.DEF _tx_index=R4
	.DEF _servo_position=R6

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer3_compa_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _usart1_rx_isr
	JMP  _usart1_tx_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

;HEAP START MARKER INITIALIZATION
__HEAP_START_MARKER:
	.DW  0,0

_0x8:
	.DB  0x1
_0x9:
	.DB  0x0,0x48
_0x2000060:
	.DB  0x1
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x04
	.DW  0x10E8
	.DW  __HEAP_START_MARKER*2

	.DW  0x01
	.DW  _current_servo_S0000002000
	.DW  _0x8*2

	.DW  0x02
	.DW  _pause_S0000002000
	.DW  _0x9*2

	.DW  0x01
	.DW  __seed_G100
	.DW  _0x2000060*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

	OUT  RAMPZ,R24

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x500

	.CSEG
;#include <mega128.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
;#include <adc.h>
;#include <stdlib.h>
;#define OCR3A (*(unsigned short *) 0x86)
;
;                                                     //Global variables
;unsigned char rx_buffer[RX_BUFFER_SIZE];
;unsigned char rx_index;
;bit status_rx_buffer=EMPTY;
;
;unsigned char tx_buffer[TX_BUFFER_SIZE];
;unsigned char tx_index;
;bit status_tx_buffer=EMPTY;
;
;int *servo_position;
;
;
;                                   //Interrupt's
;
;interrupt [USART1_RXC] void usart1_rx_isr(void)
; 0000 0015 {

	.CSEG
_usart1_rx_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0016 unsigned char status,data;
; 0000 0017 status=UCSR1A;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	LDS  R17,155
; 0000 0018 data=UDR1;
	LDS  R16,156
; 0000 0019 if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x3
; 0000 001A    {rx_buffer[rx_index++]=data;}
	MOV  R30,R5
	INC  R5
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	ST   Z,R16
; 0000 001B if (rx_index == RX_BUFFER_SIZE)
_0x3:
	LDI  R30,LOW(3)
	CP   R30,R5
	BRNE _0x4
; 0000 001C  {
; 0000 001D  rx_index=0;
	CLR  R5
; 0000 001E  status_rx_buffer=FULL;
	SET
	RJMP _0x64
; 0000 001F  }
; 0000 0020 else
_0x4:
; 0000 0021  {status_rx_buffer=EMPTY;}
	CLT
_0x64:
	BLD  R2,0
; 0000 0022 }
	LD   R16,Y+
	LD   R17,Y+
	RJMP _0x68
;
;
;interrupt [USART1_DRE] void usart1_tx_isr(void)
; 0000 0026 {
_usart1_tx_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0027   UDR1=tx_buffer[tx_index++];
	MOV  R30,R4
	INC  R4
	LDI  R31,0
	SUBI R30,LOW(-_tx_buffer)
	SBCI R31,HIGH(-_tx_buffer)
	LD   R30,Z
	STS  156,R30
; 0000 0028   if (tx_index == TX_BUFFER_SIZE)
	LDI  R30,LOW(3)
	CP   R30,R4
	BRNE _0x6
; 0000 0029   {
; 0000 002A   tx_index=0;
	CLR  R4
; 0000 002B   status_tx_buffer=EMPTY;
	CLT
	BLD  R2,1
; 0000 002C   TX_INTERRUPT_OFF;
	LDS  R30,154
	ANDI R30,0xDF
	STS  154,R30
; 0000 002D   }
; 0000 002E   else
	RJMP _0x7
_0x6:
; 0000 002F   {status_tx_buffer=FULL;}
	SET
	BLD  R2,1
_0x7:
; 0000 0030 }
_0x68:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;
;
;interrupt [TIM3_COMPA] void timer3_compa_isr(void)
; 0000 0034 {
_timer3_compa_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0035 static char current_servo=1;

	.DSEG

	.CSEG
; 0000 0036 static int pause = 18432;

	.DSEG

	.CSEG
; 0000 0037 
; 0000 0038 TCCR3C|=(1<<FOC3A);
	LDS  R30,140
	ORI  R30,0x80
	STS  140,R30
; 0000 0039 
; 0000 003A         if (current_servo == 9)
	LDS  R26,_current_servo_S0000002000
	CPI  R26,LOW(0x9)
	BRNE _0xA
; 0000 003B         {
; 0000 003C          current_servo = 0;
	LDI  R30,LOW(0)
	STS  _current_servo_S0000002000,R30
; 0000 003D          OCR3A += pause;
	LDI  R26,LOW(134)
	LDI  R27,HIGH(134)
	MOVW R0,R26
	CALL SUBOPT_0x0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
; 0000 003E          pause = 18432;
	LDI  R30,LOW(18432)
	LDI  R31,HIGH(18432)
	STS  _pause_S0000002000,R30
	STS  _pause_S0000002000+1,R31
; 0000 003F         }
; 0000 0040         else
	RJMP _0xB
_0xA:
; 0000 0041         {
; 0000 0042          OCR3A += servo_position[current_servo];
	LDI  R26,LOW(134)
	LDI  R27,HIGH(134)
	MOVW R22,R26
	LD   R0,X+
	LD   R1,X
	CALL SUBOPT_0x1
	CALL __GETW1P
	ADD  R30,R0
	ADC  R31,R1
	MOVW R26,R22
	ST   X+,R30
	ST   X,R31
; 0000 0043          pause -= servo_position[current_servo];
	CALL SUBOPT_0x1
	CALL SUBOPT_0x0
	SUB  R26,R30
	SBC  R27,R31
	STS  _pause_S0000002000,R26
	STS  _pause_S0000002000+1,R27
; 0000 0044          current_servo++;
	LDS  R30,_current_servo_S0000002000
	SUBI R30,-LOW(1)
	STS  _current_servo_S0000002000,R30
; 0000 0045         }
_0xB:
; 0000 0046 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;
;void main(void)
; 0000 004A {
_main:
; 0000 004B 
; 0000 004C 
; 0000 004D 
; 0000 004E ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 004F UCSR1A=0x00;
	LDI  R30,LOW(0)
	STS  155,R30
; 0000 0050 UCSR1B=(1<<RXCIE1)|(1<<RXEN1)|(1<<TXEN1);
	LDI  R30,LOW(152)
	STS  154,R30
; 0000 0051 UCSR1C=(1<<UCSZ11)|(1<<UCSZ10);
	LDI  R30,LOW(6)
	STS  157,R30
; 0000 0052 UBRR1H=0x00;
	LDI  R30,LOW(0)
	STS  152,R30
; 0000 0053 UBRR1L=0x2f;
	LDI  R30,LOW(47)
	STS  153,R30
; 0000 0054 #asm("sei")
	sei
; 0000 0055 
; 0000 0056  while (1)
_0xC:
; 0000 0057  {
; 0000 0058   while(status_rx_buffer==EMPTY);
_0xF:
	SBRS R2,0
	RJMP _0xF
; 0000 0059   switch (FUNCTION)
	LDS  R30,_rx_buffer
	LDI  R31,0
; 0000 005A   {
; 0000 005B   case RADAR:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x15
; 0000 005C   radar();
	RCALL _radar
; 0000 005D   break;
	RJMP _0x14
; 0000 005E 
; 0000 005F   case ROBOMD2:
_0x15:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x16
; 0000 0060   robomd2(PARAM1,PARAM2);
	__GETB1MN _rx_buffer,1
	ST   -Y,R30
	__GETB1MN _rx_buffer,2
	ST   -Y,R30
	RCALL _robomd2
; 0000 0061   while(status_tx_buffer==FULL);
_0x17:
	SBRC R2,1
	RJMP _0x17
; 0000 0062   FUNCT_TO_PC=ROBOMD2;
	LDI  R30,LOW(2)
	CALL SUBOPT_0x2
; 0000 0063   PARAM1_TO_PC=PARAM1;
; 0000 0064   PARAM2_TO_PC=PARAM2;
	RJMP _0x65
; 0000 0065   return_connect;
; 0000 0066   break;
; 0000 0067 
; 0000 0068   case SERVO:
_0x16:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x1A
; 0000 0069   servo(PARAM1,PARAM2);
	__GETB1MN _rx_buffer,1
	ST   -Y,R30
	__GETB1MN _rx_buffer,2
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	RCALL _servo
; 0000 006A   while(status_tx_buffer==FULL);
_0x1B:
	SBRC R2,1
	RJMP _0x1B
; 0000 006B   FUNCT_TO_PC=SERVO;
	LDI  R30,LOW(3)
	CALL SUBOPT_0x2
; 0000 006C   PARAM1_TO_PC=PARAM1;
; 0000 006D   PARAM2_TO_PC=PARAM2;
	RJMP _0x65
; 0000 006E   return_connect;
; 0000 006F   break;
; 0000 0070 
; 0000 0071   case ADC_FUNCT:
_0x1A:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x22
; 0000 0072   start_adc(PARAM1);
	__GETB1MN _rx_buffer,1
	ST   -Y,R30
	RCALL _start_adc
; 0000 0073   while(status_tx_buffer==FULL);
_0x1F:
	SBRC R2,1
	RJMP _0x1F
; 0000 0074   FUNCT_TO_PC=ADC_FUNCT;
	LDI  R30,LOW(4)
	STS  _tx_buffer,R30
; 0000 0075   PARAM1_TO_PC=reed_adc();
	RCALL _reed_adc
	RJMP _0x66
; 0000 0076   PARAM2_TO_PC=0;
; 0000 0077   return_connect;
; 0000 0078   break;
; 0000 0079 
; 0000 007A   default:
_0x22:
; 0000 007B   FUNCT_TO_PC=0;
	LDI  R30,LOW(0)
	STS  _tx_buffer,R30
; 0000 007C   PARAM1_TO_PC=0;              //
_0x66:
	__PUTB1MN _tx_buffer,1
; 0000 007D   PARAM2_TO_PC=0;
	LDI  R30,LOW(0)
_0x65:
	__PUTB1MN _tx_buffer,2
; 0000 007E   return_connect;
	CALL SUBOPT_0x3
; 0000 007F   }
_0x14:
; 0000 0080  }
	RJMP _0xC
; 0000 0081 
; 0000 0082 }
_0x23:
	RJMP _0x23
;
;                                              //      ADC functions
;
;void start_adc (unsigned char adc_chanel)
; 0000 0087 {
_start_adc:
; 0000 0088 if (adc_chanel>9){adc_chanel=9;}
;	adc_chanel -> Y+0
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRLO _0x24
	LDI  R30,LOW(9)
	ST   Y,R30
; 0000 0089 if (adc_chanel==9)
_0x24:
	LD   R26,Y
	CPI  R26,LOW(0x9)
	BRNE _0x25
; 0000 008A {ADC_OFF;}
	CBI  0x6,7
; 0000 008B else if
	RJMP _0x26
_0x25:
; 0000 008C (ADC==OFF)
	SBIC 0x6,7
	RJMP _0x27
; 0000 008D {ADCSRA=(1<<ADEN)|(1<<ADPS1);}
	LDI  R30,LOW(130)
	OUT  0x6,R30
; 0000 008E ADMUX=(1<<REFS0)|(1<ADLAR)|adc_chanel;
_0x27:
_0x26:
	LD   R30,Y
	ORI  R30,LOW(0x41)
	OUT  0x7,R30
; 0000 008F ADCSRA|=(1<<ADSC);
	SBI  0x6,6
; 0000 0090 }
	RJMP _0x2080005
;
;char reed_adc (void)
; 0000 0093 {
_reed_adc:
; 0000 0094 while ((ADCSRA.4)==0);
_0x28:
	SBIS 0x6,4
	RJMP _0x28
; 0000 0095 ADCSRA|=(1<<ADIF);
	SBI  0x6,4
; 0000 0096 return ADCH;
	IN   R30,0x5
	RET
; 0000 0097 }
;
;
;
;                                                  //Servo functions
;
;
;void servo (unsigned char servo, unsigned int pos)
; 0000 009F {
_servo:
; 0000 00A0 if ((servo&&pos)==0)
;	servo -> Y+2
;	pos -> Y+0
	LDD  R30,Y+2
	CPI  R30,0
	BREQ _0x2C
	LD   R30,Y
	LDD  R31,Y+1
	SBIW R30,0
	BRNE _0x2B
_0x2C:
; 0000 00A1 {
; 0000 00A2 servo_off();
	RCALL _servo_off
; 0000 00A3 return;
	RJMP _0x2080006
; 0000 00A4 }
; 0000 00A5 else if(SERV==OFF){servo_on();}
_0x2B:
	IN   R30,0x2
	CPI  R30,0
	BRNE _0x30
	LDS  R30,139
	CPI  R30,0
	BRNE _0x30
	LDS  R30,138
	CPI  R30,0
	BRNE _0x30
	LDS  R30,125
	CPI  R30,0
	BREQ _0x31
_0x30:
	RJMP _0x2F
_0x31:
	RCALL _servo_on
; 0000 00A6 if (servo>8){servo=8;}
_0x2F:
	LDD  R26,Y+2
	CPI  R26,LOW(0x9)
	BRLO _0x32
	LDI  R30,LOW(8)
	STD  Y+2,R30
; 0000 00A7 if (servo<1){servo=1;}
_0x32:
	LDD  R26,Y+2
	CPI  R26,LOW(0x1)
	BRSH _0x33
	LDI  R30,LOW(1)
	STD  Y+2,R30
; 0000 00A8 if (pos<90){pos=90;}
_0x33:
	LD   R26,Y
	LDD  R27,Y+1
	CPI  R26,LOW(0x5A)
	LDI  R30,HIGH(0x5A)
	CPC  R27,R30
	BRSH _0x34
	LDI  R30,LOW(90)
	LDI  R31,HIGH(90)
	ST   Y,R30
	STD  Y+1,R31
; 0000 00A9 if (pos>210){pos=210;}
_0x34:
	LD   R26,Y
	LDD  R27,Y+1
	CPI  R26,LOW(0xD3)
	LDI  R30,HIGH(0xD3)
	CPC  R27,R30
	BRLO _0x35
	LDI  R30,LOW(210)
	LDI  R31,HIGH(210)
	ST   Y,R30
	STD  Y+1,R31
; 0000 00AA servo_position[servo]=(pos*20);
_0x35:
	CALL SUBOPT_0x4
	ADD  R30,R26
	ADC  R31,R27
	__PUTW1R 23,24
	LD   R26,Y
	LDD  R27,Y+1
	LDI  R30,LOW(20)
	CALL __MULB1W2U
	__GETW2R 23,24
	ST   X+,R30
	ST   X,R31
; 0000 00AB }
	RJMP _0x2080006
;
;void servo_on (void)
; 0000 00AE {
_servo_on:
; 0000 00AF char i;
; 0000 00B0 servo_position=(int*)malloc(9*sizeof(int));
	ST   -Y,R17
;	i -> R17
	LDI  R30,LOW(18)
	LDI  R31,HIGH(18)
	ST   -Y,R31
	ST   -Y,R30
	CALL _malloc
	MOVW R6,R30
; 0000 00B1 for (i=0;i<9;i++)
	LDI  R17,LOW(0)
_0x37:
	CPI  R17,9
	BRSH _0x38
; 0000 00B2     servo_position[i]=3000;
	MOV  R30,R17
	MOVW R26,R6
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   X+,R30
	ST   X,R31
	SUBI R17,-1
	RJMP _0x37
_0x38:
; 0000 00B3 DDRE|=(1<<3       )|(1<<2       );
	IN   R30,0x2
	ORI  R30,LOW(0xC)
	OUT  0x2,R30
; 0000 00B4 PORTE&=~(1<<PORTE3)|(1<<PORTE2);
	CBI  0x3,3
; 0000 00B5 PORTE.2=1;
	SBI  0x3,2
; 0000 00B6 OCR3A=2000;
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	STS  134,R30
	STS  134+1,R31
; 0000 00B7 TCCR3A=(1<<COM3A0);
	LDI  R30,LOW(64)
	STS  139,R30
; 0000 00B8 TCCR3B=(1<<CS31);
	LDI  R30,LOW(2)
	STS  138,R30
; 0000 00B9 ETIMSK|=(1<<OCIE3A);
	LDS  R30,125
	ORI  R30,0x10
	STS  125,R30
; 0000 00BA PORTE.2=0;
	CBI  0x3,2
; 0000 00BB }
	LD   R17,Y+
	RET
;
;void servo_off (void)
; 0000 00BE {
_servo_off:
; 0000 00BF DDRE&=~(1<<DDE3)|(1<<DDE2);
	CBI  0x2,3
; 0000 00C0 TCCR3A=0x00;
	LDI  R30,LOW(0)
	STS  139,R30
; 0000 00C1 TCCR3B=0x00;
	STS  138,R30
; 0000 00C2 ETIMSK&=~(1<<OCIE3A);
	LDS  R30,125
	ANDI R30,0xEF
	STS  125,R30
; 0000 00C3 free(servo_position);
	ST   -Y,R7
	ST   -Y,R6
	CALL _free
; 0000 00C4 }
	RET
;
;unsigned int get_servo_position (char servo)
; 0000 00C7 {
_get_servo_position:
; 0000 00C8 unsigned int position;
; 0000 00C9 position=((servo_position[servo]/20));
	ST   -Y,R17
	ST   -Y,R16
;	servo -> Y+2
;	position -> R16,R17
	CALL SUBOPT_0x4
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	CALL __DIVW21
	MOVW R16,R30
; 0000 00CA return position;
	MOVW R30,R16
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x2080006:
	ADIW R28,3
	RET
; 0000 00CB }
;
;
;                                                  //Motor functions
;
;
;
;void robomd2 (unsigned char m1, unsigned char m2)
; 0000 00D3 {
_robomd2:
; 0000 00D4  if ((PWM_1==0)&&(PWM_2==0)&&(m1==0)&&(m2==0))
;	m1 -> Y+1
;	m2 -> Y+0
	IN   R30,0x2A
	IN   R31,0x2A+1
	SBIW R30,0
	BRNE _0x3E
	IN   R30,0x28
	IN   R31,0x28+1
	SBIW R30,0
	BRNE _0x3E
	LDD  R26,Y+1
	CPI  R26,LOW(0x0)
	BRNE _0x3E
	LD   R26,Y
	CPI  R26,LOW(0x0)
	BREQ _0x3F
_0x3E:
	RJMP _0x3D
_0x3F:
; 0000 00D5  {
; 0000 00D6  pwm_off();
	RCALL _pwm_off
; 0000 00D7  return;
	RJMP _0x2080002
; 0000 00D8  }
; 0000 00D9  else
_0x3D:
; 0000 00DA  if(PWM==OFF){pwm_on();}
	IN   R30,0x2F
	CPI  R30,0
	BRNE _0x42
	IN   R30,0x2E
	CPI  R30,0
	BRNE _0x42
	IN   R30,0x17
	CPI  R30,0
	BRNE _0x42
	IN   R30,0x14
	CPI  R30,0
	BREQ _0x43
_0x42:
	RJMP _0x41
_0x43:
	RCALL _pwm_on
; 0000 00DB  motor1(m1);
_0x41:
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _motor1
; 0000 00DC  motor2(m2);
	LD   R30,Y
	ST   -Y,R30
	RCALL _motor2
; 0000 00DD }
	RJMP _0x2080002
;
;void pwm_on(void)
; 0000 00E0 {
_pwm_on:
; 0000 00E1 TCCR1A=0x01;
	LDI  R30,LOW(1)
	OUT  0x2F,R30
; 0000 00E2 TCCR1B=0b00001010;
	LDI  R30,LOW(10)
	OUT  0x2E,R30
; 0000 00E3 DDRB|=(1<<DDB6)|(1<<DDB5);
	IN   R30,0x17
	ORI  R30,LOW(0x60)
	OUT  0x17,R30
; 0000 00E4 PORTB&=~(1<<PORTB6)|(1<<PORTB7);
	CBI  0x18,6
; 0000 00E5 DDRC|=(1<<DDC7)|(1<<DDC6);
	IN   R30,0x14
	ORI  R30,LOW(0xC0)
	OUT  0x14,R30
; 0000 00E6 PORTC&=~(1<<PORTC7)|(1<<PORTC6);
	CBI  0x15,7
; 0000 00E7 }
	RET
;void pwm_off(void)
; 0000 00E9 {
_pwm_off:
; 0000 00EA TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
; 0000 00EB TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 00EC DDRB&=~(1<<DDB6)|(1<<DDB5);
	CBI  0x17,6
; 0000 00ED DDRC&=~(1<<DDC7)|(1<<DDC6);
	CBI  0x14,7
; 0000 00EE }
	RET
;
;void motor1 (unsigned char m1)
; 0000 00F1 {
_motor1:
; 0000 00F2  if ((m1==0)&&(PWM_1==OFF))
;	m1 -> Y+0
	LD   R26,Y
	CPI  R26,LOW(0x0)
	BRNE _0x45
	IN   R30,0x2A
	IN   R31,0x2A+1
	SBIW R30,0
	BREQ _0x46
_0x45:
	RJMP _0x44
_0x46:
; 0000 00F3  {
; 0000 00F4  PWM_OFF(1);
	IN   R30,0x2F
	ANDI R30,0x7F
	OUT  0x2F,R30
; 0000 00F5  return;
	RJMP _0x2080005
; 0000 00F6  }
; 0000 00F7  else
_0x44:
; 0000 00F8  if(PWM_1==OFF)
	IN   R30,0x2A
	IN   R31,0x2A+1
	SBIW R30,0
	BRNE _0x48
; 0000 00F9  {PWM_ON(1);}
	IN   R30,0x2F
	ORI  R30,0x80
	OUT  0x2F,R30
; 0000 00FA 
; 0000 00FB  if(testbit(m1,0))
_0x48:
	CALL SUBOPT_0x5
	ANDI R30,LOW(0x1)
	BREQ _0x49
; 0000 00FC  {FORWARD_M1;}
	CBI  0x15,6
; 0000 00FD  else
	RJMP _0x4C
_0x49:
; 0000 00FE  {REVERS_M1;}
	SBI  0x15,6
_0x4C:
; 0000 00FF  PWM_1=m1;
	CALL SUBOPT_0x5
	OUT  0x2A+1,R31
	OUT  0x2A,R30
; 0000 0100 
; 0000 0101 }
	RJMP _0x2080005
;
;void motor2 (unsigned char m2)
; 0000 0104 {
_motor2:
; 0000 0105  if ((m2==0)&&(PWM_2==OFF))
;	m2 -> Y+0
	LD   R26,Y
	CPI  R26,LOW(0x0)
	BRNE _0x50
	IN   R30,0x28
	IN   R31,0x28+1
	SBIW R30,0
	BREQ _0x51
_0x50:
	RJMP _0x4F
_0x51:
; 0000 0106  {
; 0000 0107  PWM_OFF(2);
	IN   R30,0x2F
	ANDI R30,0xDF
	OUT  0x2F,R30
; 0000 0108  return;
	RJMP _0x2080005
; 0000 0109  }
; 0000 010A  else
_0x4F:
; 0000 010B  if(PWM_2==OFF)
	IN   R30,0x28
	IN   R31,0x28+1
	SBIW R30,0
	BRNE _0x53
; 0000 010C  {PWM_ON(2);}
	IN   R30,0x2F
	ORI  R30,0x20
	OUT  0x2F,R30
; 0000 010D 
; 0000 010E  if(testbit(m2,0))
_0x53:
	CALL SUBOPT_0x5
	ANDI R30,LOW(0x1)
	BREQ _0x54
; 0000 010F  {FORWARD_M2;}
	CBI  0x15,7
; 0000 0110  else
	RJMP _0x57
_0x54:
; 0000 0111  {REVERS_M2;}
	SBI  0x15,7
_0x57:
; 0000 0112  PWM_2=m2;
	CALL SUBOPT_0x5
	OUT  0x28+1,R31
	OUT  0x28,R30
; 0000 0113 }
_0x2080005:
	ADIW R28,1
	RET
;
;
;
;
;                                           //radar function
;void radar(void)
; 0000 011A {
_radar:
; 0000 011B static bit radar_move;
; 0000 011C start_adc(SHARP);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _start_adc
; 0000 011D servo_on();
	RCALL _servo_on
; 0000 011E switch(radar_move)
	LDI  R30,0
	SBRC R2,2
	LDI  R30,1
; 0000 011F {
; 0000 0120  case 0:
	CPI  R30,0
	BRNE _0x5D
; 0000 0121  if(servo_position[RADAR]<=2500)
	MOVW R30,R6
	LDD  R26,Z+2
	LDD  R27,Z+3
	CPI  R26,LOW(0x9C5)
	LDI  R30,HIGH(0x9C5)
	CPC  R27,R30
	BRGE _0x5E
; 0000 0122  {
; 0000 0123  radar_move=1;
	SET
	BLD  R2,2
; 0000 0124  break;
	RJMP _0x5C
; 0000 0125  }
; 0000 0126  servo_position[RADAR]--;
_0x5E:
	MOVW R26,R6
	ADIW R26,2
	LD   R30,X+
	LD   R31,X+
	SBIW R30,1
	RJMP _0x67
; 0000 0127  break;
; 0000 0128 
; 0000 0129  case 1:
_0x5D:
	CPI  R30,LOW(0x1)
	BRNE _0x5C
; 0000 012A  if(servo_position[RADAR]>=3500)
	MOVW R30,R6
	LDD  R26,Z+2
	LDD  R27,Z+3
	CPI  R26,LOW(0xDAC)
	LDI  R30,HIGH(0xDAC)
	CPC  R27,R30
	BRLT _0x60
; 0000 012B  {
; 0000 012C  radar_move=0;
	CLT
	BLD  R2,2
; 0000 012D  break;
	RJMP _0x5C
; 0000 012E  }
; 0000 012F  servo_position[RADAR]++;
_0x60:
	MOVW R26,R6
	ADIW R26,2
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
_0x67:
	ST   -X,R31
	ST   -X,R30
; 0000 0130  break;
; 0000 0131 }
_0x5C:
; 0000 0132 while(status_tx_buffer==FULL);
_0x61:
	SBRC R2,1
	RJMP _0x61
; 0000 0133 FUNCT_TO_PC=RADAR;
	LDI  R30,LOW(1)
	STS  _tx_buffer,R30
; 0000 0134 PARAM1_TO_PC=get_servo_position(RADAR);
	ST   -Y,R30
	RCALL _get_servo_position
	__PUTB1MN _tx_buffer,1
; 0000 0135 PARAM2_TO_PC=reed_adc();
	RCALL _reed_adc
	__PUTB1MN _tx_buffer,2
; 0000 0136 return_connect;
	CALL SUBOPT_0x3
; 0000 0137 }
	RET
;
;
;

	.CSEG

	.DSEG

	.CSEG
_allocate_block_G100:
	SBIW R28,2
	CALL __SAVELOCR6
	__GETWRN 16,17,4328
	MOVW R26,R16
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2000061:
	MOV  R0,R16
	OR   R0,R17
	BREQ _0x2000063
	MOVW R26,R16
	CALL __GETW1P
	ADD  R30,R16
	ADC  R31,R17
	ADIW R30,4
	MOVW R20,R30
	ADIW R26,2
	CALL __GETW1P
	MOVW R18,R30
	SBIW R30,0
	BREQ _0x2000064
	__PUTWSR 18,19,6
	RJMP _0x2000065
_0x2000064:
	LDI  R30,LOW(4352)
	LDI  R31,HIGH(4352)
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x2000065:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SUB  R26,R20
	SBC  R27,R21
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,4
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x2000066
	MOVW R30,R20
	__PUTW1RNS 16,2
	MOVW R30,R18
	__PUTW1RNS 20,2
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	MOVW R26,R20
	ST   X+,R30
	ST   X,R31
	__ADDWRN 20,21,4
	MOVW R30,R20
	RJMP _0x2080004
_0x2000066:
	MOVW R16,R18
	RJMP _0x2000061
_0x2000063:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x2080004:
	CALL __LOADLOCR6
	ADIW R28,10
	RET
_find_prev_block_G100:
	CALL __SAVELOCR4
	__GETWRN 16,17,4328
_0x2000067:
	MOV  R0,R16
	OR   R0,R17
	BREQ _0x2000069
	MOVW R26,R16
	ADIW R26,2
	CALL __GETW1P
	MOVW R18,R30
	MOVW R26,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x200006A
	MOVW R30,R16
	CALL __LOADLOCR4
	JMP  _0x2080001
_0x200006A:
	MOVW R16,R18
	RJMP _0x2000067
_0x2000069:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	CALL __LOADLOCR4
	JMP  _0x2080001
_realloc:
	SBIW R28,2
	CALL __SAVELOCR6
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SBIW R30,0
	BRNE PC+3
	JMP _0x200006B
	SBIW R30,4
	MOVW R16,R30
	ST   -Y,R17
	ST   -Y,R16
	RCALL _find_prev_block_G100
	MOVW R18,R30
	SBIW R30,0
	BREQ _0x200006C
	MOVW R26,R16
	ADIW R26,2
	CALL __GETW1P
	__PUTW1RNS 18,2
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	SBIW R30,0
	BREQ _0x200006D
	ST   -Y,R31
	ST   -Y,R30
	RCALL _allocate_block_G100
	MOVW R20,R30
	SBIW R30,0
	BREQ _0x200006E
	MOVW R26,R16
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	MOVW R26,R30
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	CP   R26,R30
	CPC  R27,R31
	BRSH _0x200006F
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	STD  Y+8,R30
	STD  Y+8+1,R31
_0x200006F:
	ST   -Y,R21
	ST   -Y,R20
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _memmove
	MOVW R30,R20
	RJMP _0x2080003
_0x200006E:
	MOVW R30,R16
	__PUTW1RNS 18,2
_0x200006D:
_0x200006C:
_0x200006B:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x2080003:
	CALL __LOADLOCR6
	ADIW R28,12
	RET
_malloc:
	ST   -Y,R17
	ST   -Y,R16
	__GETWRN 16,17,0
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SBIW R30,0
	BREQ _0x2000070
	ST   -Y,R31
	ST   -Y,R30
	RCALL _allocate_block_G100
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000071
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _memset
_0x2000071:
_0x2000070:
	MOVW R30,R16
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	RET
_free:
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _realloc
_0x2080002:
	ADIW R28,2
	RET

	.CSEG

	.CSEG

	.CSEG
_memmove:
    ldd  r25,y+1
    ld   r24,y
    adiw r24,0
    breq memmove3
    ldd  r27,y+5
    ldd  r26,y+4
    ldd  r31,y+3
    ldd  r30,y+2
    cp   r30,r26
    cpc  r31,r27
    breq memmove3
    brlt memmove1
memmove0:
    ld   r22,z+
    st   x+,r22
    sbiw r24,1
    brne memmove0
    rjmp memmove3
memmove1:
    add  r26,r24
    adc  r27,r25
    add  r30,r24
    adc  r31,r25
memmove2:
    ld   r22,-z
    st   -x,r22
    sbiw r24,1
    brne memmove2
memmove3:
    ldd  r31,y+5
    ldd  r30,y+4
_0x2080001:
	ADIW R28,6
	RET
_memset:
    ldd  r27,y+1
    ld   r26,y
    adiw r26,0
    breq memset1
    ldd  r31,y+4
    ldd  r30,y+3
    ldd  r22,y+2
memset0:
    st   z+,r22
    sbiw r26,1
    brne memset0
memset1:
    ldd  r30,y+3
    ldd  r31,y+4
	ADIW R28,5
	RET

	.DSEG
_rx_buffer:
	.BYTE 0x3
_tx_buffer:
	.BYTE 0x3
_current_servo_S0000002000:
	.BYTE 0x1
_pause_S0000002000:
	.BYTE 0x2
__seed_G100:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	CALL __GETW1P
	LDS  R26,_pause_S0000002000
	LDS  R27,_pause_S0000002000+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1:
	LDS  R30,_current_servo_S0000002000
	MOVW R26,R6
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2:
	STS  _tx_buffer,R30
	__GETB1MN _rx_buffer,1
	__PUTB1MN _tx_buffer,1
	__GETB1MN _rx_buffer,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3:
	LDS  R30,154
	ORI  R30,0x20
	STS  154,R30
	CLT
	BLD  R2,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4:
	LDD  R30,Y+2
	MOVW R26,R6
	LDI  R31,0
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5:
	LD   R30,Y
	LDI  R31,0
	RET


	.CSEG
__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__MULB1W2U:
	MOV  R22,R30
	MUL  R22,R26
	MOVW R30,R0
	MUL  R22,R27
	ADD  R31,R0
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
