#ifndef _ADC_INCLUDED_
#define _ADC_INCLUDED_

#define testbit(data,bitno) ((data>>bitno)&0x01)
#define ADC_OFF ADCSRA&=~(1<<ADEN)
#define ADC  ADCSRA.7   
#define OFF 0
#define ON  1
#define SERV (DDRE||TCCR3A||TCCR3B||ETIMSK)

#ifndef RXB8
#define RXB8 1
#endif

#ifndef TXB8
#define TXB8 0
#endif

#ifndef UPE
#define UPE 2
#endif

#ifndef DOR
#define DOR 3
#endif

#ifndef FE
#define FE 4
#endif

#ifndef UDRE
#define UDRE 5
#endif

#ifndef TXC
#define TXC 6
#endif


#ifndef RXC
#define RXC 7
#endif

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<DOR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

#define RX_BUFFER_SIZE 3
#define TX_BUFFER_SIZE 3
#define FUNCTION   rx_buffer[0]
#define PARAM1     rx_buffer[1]
#define PARAM2     rx_buffer[2]
#define FUNCT_TO_PC   tx_buffer[0]
#define PARAM1_TO_PC   tx_buffer[1]
#define PARAM2_TO_PC   tx_buffer[2]
#define FULL  1
#define EMPTY 0
#define TX_INTERRUPT_ON  UCSR1B|=(1<<UDRIE1)
#define TX_INTERRUPT_OFF UCSR1B&=~(1<<UDRIE1)
#define return_connect  TX_INTERRUPT_ON; status_rx_buffer=EMPTY;

#define RADAR   1
#define SHARP   0
#define ROBOMD2 2
#define SERVO   3
#define ADC_FUNCT 4 

#define PWM_1 OCR1A
#define PWM_2 OCR1B
#define PWM (TCCR1A||TCCR1B||DDRB||DDRC)
#define COM_PWM1    ((1<<COM1A1)|(0<<COM1A0))
#define COM_PWM2    ((1<<COM1B1)|(0<<COM1A0))
#define PWM_ON(ch)  TCCR1A|=COM_PWM##ch
#define PWM_OFF(ch) TCCR1A&=~COM_PWM##ch
#define FORWARD_M1  PORTC.6=0
#define FORWARD_M2  PORTC.7=0
#define REVERS_M1   PORTC.6=1
#define REVERS_M2   PORTC.7=1
#pragma used+

void radar(void);

void start_adc (unsigned char adc_chanel);
unsigned char reed_adc (void);

void servo (unsigned char servo, unsigned int pos);
void servo_on (void);
void servo_off (void);
unsigned int get_servo_position (char servo);

void robomd2(unsigned char m1, unsigned char m2);
void pwm_on(void);
void pwm_off(void);
void motor1(unsigned char m1);
void motor2(unsigned char m2);

#pragma used-
#endif
